#include "debug.h"

int debug_mask;
#ifdef DEBUG_ENABLED

#include <qmutex.h>
#include <stdio.h>
#include <stdarg.h>

/*
	Poniewa debug() moe by uywany w rnych wtkach,
	wic zastosowaem semafor, aby unikn wywietlenia
	na ekranie czego przez inny wtek pomidzy
	poszczeglnymi wywoaniami fprintf
*/
static QMutex debug_mutex;

void _kdebug_with_mask(int mask, const char* file,const int line,const char* format,...)
{
	if (debug_mask & mask)
	{
		debug_mutex.lock();
		fprintf(stderr,"KK <%s:%i>\t",file,line);
		va_list args;
		va_start(args,format);
		vfprintf(stderr,format,args);
		va_end(args);
		debug_mutex.unlock();
	}
}

#endif
